<template>
    <div class="w-full flex flex-row">
        <div class="flex flex-col m-2 bg-gray-200 p-2 w-full">
            <div class="headline flex flex-row items-center mb-2">
                <div class="flex-grow text-md uppercase"> Types <span v-if="project.types" class="px-2 text-xs bg-gray-500 text-gray-100 mx-2 rounded-full">{{project.types.length}}</span> </div>
                <div class="actions">
                    <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="add()">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/add-solid.svg" />
                        <span>Add Type</span>
                    </button>
                </div>
            </div>
            <div class="w-full bg-white">
                <table class="relative table-auto w-full">
                    <thead>
                        <tr class="border-b border-gray-200">
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Id</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Name</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Colors</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Actions</th>
                        </tr>
                    </thead>
                    <tbody class="bg-white overflow-y-auto w-full">
                        <tr v-for="(type, index) in project.types" :key="type.id" :class="{'bg-gray-100': ((type.id != selectedType.id) && (index % 2)), 'bg-white': ((type.id != selectedType.id) && !(index % 2)), 'bg-yellow-300': (!selectedTypeModified && type.id == selectedType.id), 'bg-orange-300': (selectedTypeModified && type.id == selectedType.id)}">
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="flex flex-col items-center content-center">
                                    <div class="px-2 rounded-full mt-2">
                                        <span class="text-xs">{{type.id}}</span>
                                    </div>
                                </div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full">{{type.name}}</div>
                                <div class="text-sm leading-5 text-gray-900 whitespace-pre-line w-full">{{type.label}}</div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="colors flex flex-row flex-wrap">
                                    <div v-if="type.properties.color" class="color flex flex-row mr-2 items-center text-xs"> <span class="px-2 h-full rounded-l-lg border-l-2 text-sm" :class="[colors[type.properties.color].dark.bg, colors[type.properties.color].light.text]"> Default </span> <span class="px-2 rounded-r-lg border-t-2 border-b-2 border-r-2" :style="{borderColor: colors[type.properties.color].dark.color}"> {{type.properties.color}} </span> </div>
                                    <div v-if="type.properties.status.active" class="color flex flex-row mr-2 items-center text-xs"> <span class="px-2 h-full rounded-l-lg text-sm" :class="[colors[type.properties.status.active].dark.bg, colors[type.properties.status.active].light.text]"> Active </span> <span class="px-2 rounded-r-lg border-t-2 border-b-2 border-r-2" :style="{borderColor: colors[type.properties.status.active].dark.color}"> {{type.properties.status.active}} </span></div>
                                    <div v-if="type.properties.status.inactive" class="color flex flex-row mr-2 items-center text-xs"> <span class="px-2 h-full rounded-l-lg text-sm" :class="[colors[type.properties.status.inactive].dark.bg, colors[type.properties.status.inactive].light.text]"> Inactive </span> <span class="px-2 rounded-r-lg border-t-2 border-b-2 border-r-2" :style="{borderColor: colors[type.properties.status.inactive].dark.color}"> {{type.properties.status.inactive}} </span></div>
                                </div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <button class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="edit(type)">
                                    <img svg-inline src="./pix/zond/edit-pencil.svg" class="w-4 h-4 fill-current" />
                                </button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <div v-if="typeof selectedType.id !== 'undefined'" class="type flex-shrink bg-gray-200 m-2 p-4 flex flex-col">
            <div class="headline flex flex-row items-center mb-2 whitespace-no-wrap">
                <div class="flex-grow text-md uppercase"> Type <span v-if="selectedType.name" class="px-2 text-xs bg-gray-500 text-gray-100 mx-2 rounded-full">#{{selectedType.id}}</span> </div>
                <div class="actions">
                    <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="save(selectedType)">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/checkmark.svg" />
                        <span v-if="selectedType.id">Save</span>
                        <span v-else>Create</span>
                    </button>
                    <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="cancel()">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/close-solid.svg" />
                        <span>Cancel</span>
                    </button>
                    <button v-if="selectedType.id" class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="remove(selectedType)">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/trash.svg" />
                        <span>Delete</span>
                    </button>
                </div>
            </div>
            <div class="relative bg-white w-full p-2 rounded-lg">
                <div class="input flex flex-col items-start mb-1 py-1 px-2 text-sm">
                    <label class="mb-1 font-semibold capitalize truncate">Name</label>
                    <input type="text" v-model="selectedType.name" class="w-full h-8 border rounded-md px-2" />
                </div>
                <div class="input flex flex-col items-start mb-1 py-1 px-2 text-sm">
                    <label class="mb-1 font-semibold capitalize truncate">Label</label>
                    <input type="text" v-model="selectedType.label" class="w-full h-8 border rounded-md px-2" />
                </div>
                <div class="input flex flex-col items-start mb-1 py-1 px-2 text-sm shadow-lg border m-2">
                    <label class="mb-1 font-semibold capitalize truncate">Colors</label>
                    <div class="flex flex-row w-full">
                        <div class="input flex flex-col items-center mb-1 py-1 px-2 text-sm w-full border-r">
                            <v-swatches v-model="selectedType.properties.color" :swatches="swatches" row-length="5" shapes="circles" show-border></v-swatches>
                            <label class="mb-1 font-semibold capitalize truncate">Default</label>
                        </div>
                        <div class="input flex flex-col items-center mb-1 py-1 px-2 text-sm w-full border-r">
                            <v-swatches v-model="selectedType.properties.status.active" :swatches="swatches" row-length="5" shapes="circles" show-border></v-swatches>
                            <label class="mb-1 font-semibold capitalize truncate">Active</label>
                        </div>
                        <div class="input flex flex-col items-center mb-1 py-1 px-2 text-sm w-full">
                            <v-swatches v-model="selectedType.properties.status.inactive" :swatches="swatches" row-length="5" shapes="circles" show-border></v-swatches>
                            <label class="mb-1 font-semibold capitalize truncate">Inactive</label>
                        </div>
                    </div>
                </div>
                <wee-modal ref="creation" :timeout="2000">
                    <template v-slot:loading="e">
                        <img src="./pix/infinity-transparent.png" class="block relative m-auto" />
                        <div class="text-white w-full text-center">
                            Creating type {{e.data.name}} on project {{project.id}}
                        </div>
                    </template>
                    <template v-slot:success="e">
                        <div class="block relative m-auto">
                            <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                        </div>
                        <div class="text-white w-full text-center">
                            Successfully created type {{e.data.id}}
                        </div>
                    </template>
                    <template v-slot:failure="e">
                        <div class="block relative m-auto">
                            <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-down.svg" />
                        </div>
                        <div class="text-white w-full text-center">
                            Failed to create type {{e.data.name}} because
                            <div class="text-pink-200">{{e.data.message}}</div>
                        </div>
                    </template>
                </wee-modal>
                <wee-modal ref="updation" :timeout="2000">
                    <template v-slot:loading="e">
                        <img src="./pix/infinity-transparent.png" class="block relative m-auto" />
                        <div class="text-white w-full text-center">
                            Updating type {{e.data.id}} on project {{project.id}}
                        </div>
                    </template>
                    <template v-slot:success="e">
                        <div class="block relative m-auto">
                            <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                        </div>
                        <div class="text-white w-full text-center">
                            Successfully updated type {{e.data.id}}
                        </div>
                    </template>
                    <template v-slot:failure="e">
                        <div class="block relative m-auto">
                            <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-down.svg" />
                        </div>
                        <div class="text-white w-full text-center">
                            Failed to update type {{e.data.id}} because
                            <div class="text-pink-200">{{e.data.message}}</div>
                        </div>
                    </template>
                </wee-modal>
            </div>
        </div>
    </div>
</template>
<script>
import Vue from 'vue'
import {themes} from './themes.js';
import vSelect from 'vue-select'
import VSwatches from 'vue-swatches'
import WeeModal from './WeeModal'
import axios from 'axios'
import './style.css';
import 'vue-select/dist/vue-select.css';
import 'vue-swatches/dist/vue-swatches.css'

Vue.component('v-select', vSelect);

export default{
    name: "WeeSpatialProjectTypesEditor",
    props: ["project"],
    components: { 
        VSwatches,
        WeeModal
    },
    data(){
        return {
            colors: themes,
            swatches: Object.keys(themes).map(function(c){
                return {color: c, label: c}
            }),
            selectedType: {},
            selectedTypeBackup: null,
            unsavedType: {
                id: 0,
                name: "",
                label: "",
                properties: {
                    color: "pink",
                    status: {
                        active: "red",
                        inactive: "gray"
                    }
                }
            }
        };
    },
    methods: {
        add(){
            this.cancel();
            this.selectedType = this.unsavedType;
            this.selectedTypeBackup = null;
        },
        edit(type){
            this.cancel();
            this.selectedType = type;
            this.selectedTypeBackup = JSON.stringify(type);
        },
        updated(){
            this.selectedTypeBackup = JSON.stringify(this.selectedType);
        },
        cancel(){
            this.selectedType = {};
            this.selectedTypeBackup = null;
        },
        remove(type){
            
        },
        create(){
            let self = this;
            this.$refs.creation.activate({
                name: this.selectedType.name
            });
            axios.post(this.createUrl, this.selectedType).then(function(response){
                if(response.data.success){
                    self.$refs.creation.done({
                        id: response.data.id
                    });
                    self.$emit('added');
                }else{
                    self.$refs.creation.failed({
                        name: self.selectedType.name,
                        message: response.data.message
                    });
                }
            }).catch(function(error){
                self.$refs.creation.failed({
                    name: self.selectedType.name,
                    message: error
                });
            });
        },
        update(){
            let self = this;
            this.$refs.updation.activate({
                id: this.selectedType.id
            });
            axios.post(this.updateUrl, this.selectedType).then(function(response){
                if(response.data.success){
                    self.$refs.updation.done({
                        id: response.data.id
                    });
                    self.$emit('updated');
                    self.updated();
                }else{
                    self.$refs.updation.failed({
                        id: self.selectedType.id,
                        message: response.data.message
                    });
                }
            }).catch(function(error){
                self.$refs.updation.failed({
                    id: self.selectedType.id,
                    message: error
                });
            });
        },
        save(){
            if(this.selectedType.id == 0){
                this.create();
            }else{
                this.update();
            }
        }
    },
    computed: {
        createUrl(){
            return '/types/create/'+this.project.id;
        },
        updateUrl(){
            return '/types/'+this.selectedType.id;
        },
        selectedTypeModified(){
            if(this.selectedType.id && this.selectedTypeBackup){
                return (JSON.stringify(this.selectedType) != this.selectedTypeBackup);
            }
            return false;
        }
    }
}
</script>
<style>

</style>
